Tests: Count number of chunk using ls
[lttng-tools.git] / tests / regression / tools / rotation / rotate_utils.sh
index 1a78c174bdb8ef9d24111484c4d4ecf0fdf2481e..a90c1fea0b8cbdb75a173314264293bdec47559d 100644 (file)
@@ -1,9 +1,37 @@
+#!/bin/bash
+#
+# Copyright (C) - 2017 Julien Desfossez <jdesfossez@efficios.com>
+#
+# This library is free software; you can redistribute it and/or modify it under
+# the terms of the GNU Lesser General Public License as published by the Free
+# Software Foundation; version 2.1 of the License.
+#
+# This library is distributed in the hope that it will be useful, but WITHOUT
+# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+# FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more
+# details.
+#
+# You should have received a copy of the GNU Lesser General Public License
+# along with this library; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301 USA
+
+# Clean everything under directory but keep directory
+function clean_path ()
+{
+       local path=$1
+       # Use -u from bash top prevent empty expansion of variable yielding a
+       # list of current directory from find.
+       set -u
+       find $path -mindepth 1 -maxdepth 1 -exec rm -rf '{}' \;
+       set +u
+}
+
 function set_chunk_pattern ()
 {
        # Need to call this function after $today has been set.
 
-       # YYYYMMDD-HHMMSS-YYYYMMDD-HHMMSS
-       export chunk_pattern="${today}-[0-9][0-9][0-9][0-9][0-9][0-9]-${today}-[0-9][0-9][0-9][0-9][0-9][0-9]"
+       # YYYYMMDDTHHMMSS[+-]HHMM-YYYYMMDDTHHMMSS[+-]HHMM
+       export chunk_pattern="${today}T[0-9][0-9][0-9][0-9][0-9][0-9][+-][0-9][0-9][0-9][0-9]-${today}T[0-9][0-9][0-9][0-9][0-9][0-9][+-][0-9][0-9][0-9][0-9]"
 }
 
 function validate_test_chunks ()
@@ -15,14 +43,27 @@ function validate_test_chunks ()
        per_pid=$5
 
        set_chunk_pattern
+       local path=
 
-       # Check if the 3 chunk folders exist and they contain a ${app_path}/metadata file.
-       ls $local_path/${chunk_pattern}-1/${app_path}/metadata >/dev/null
-       ok $? "Chunk 1 exists"
-       ls $local_path/${chunk_pattern}-2/${app_path}/metadata >/dev/null
-       ok $? "Chunk 2 exists"
-       ls $local_path/${chunk_pattern}-3/${domain} >/dev/null
-       ok $? "Chunk 3 exists"
+       # Validate that only 3 chunks are present
+       nb_chunk=$(ls -A $local_path | wc -l)
+       test $nb_chunk -eq 3
+       ok $? "${local_path} contains 3 chunks only"
+
+       # Check if the first and second chunk folders exist and they contain a ${app_path}/metadata file.
+       for chunk in $(seq 1 2); do
+               path=$(ls $local_path/${chunk_pattern}-${chunk}/${app_path}/metadata)
+               ok $? "Chunk ${chunk} exists based on path $path"
+       done
+
+       # In per-pid the last chunk (3) must be empty.
+       if [ "${per_pid}" -eq "1" ]; then
+               test -z "$(ls -A $local_path/${chunk_pattern}-3/${domain})"
+               ok $? "Chunk 3 is empty per-pid mode"
+       else
+               path=$(ls $local_path/${chunk_pattern}-3/${app_path}/metadata)
+               ok $? "Chunk 3 exists based on path $path"
+       fi
 
        # Make sure we don't have anything else in the first 2 chunk directories
        # besides the kernel folder.
@@ -31,45 +72,20 @@ function validate_test_chunks ()
        nr_stale=$(\ls $local_path/${chunk_pattern}-2 | grep -v $domain | wc -l)
        ok $nr_stale "No stale folders in chunk 2 directory"
 
-       # We expect a session of 30 events
+       # We expect a complete session of 30 events
        validate_trace_count $EVENT_NAME $local_path 30
 
        # Chunk 1: 10 events
        validate_trace_count $EVENT_NAME $local_path/${chunk_pattern}-1 10
-       if [ $? -eq 0 ]; then
-               # Only delete if successful
-               rm -rf $local_path/${chunk_pattern}-1
-       fi
 
        # Chunk 2: 20 events
        validate_trace_count $EVENT_NAME $local_path/${chunk_pattern}-2 20
-       if [ $? -eq 0 ]; then
-               # Only delete if successful
-               rm -rf $local_path/${chunk_pattern}-2
-       fi
 
        # Chunk 3: 0 event
-       # Do not check in per-pid, because the folder is really empty, no metadata
-       # or stream files.
-       if test $per_pid = 1; then
-               rm -rf $local_path/${chunk_pattern}-3
-       else
+       # Trace for chunk number 3 can only be read in per-uid mode since in
+       # per-pid mode it is empty (no metadata or stream files).
+       if test $per_pid = 0; then
                validate_trace_empty $local_path/${chunk_pattern}-3
-               if [ $? -eq 0 ]; then
-                       # Only delete if successful
-                       rm -rf $local_path/${chunk_pattern}-3
-               fi
-       fi
-
-       # The session folder after all chunks have been removed is empty
-       test -z "$(\ls -A $local_path)"
-       empty=$?
-       ok $empty "Trace folder is now empty"
-       if [ $empty -eq 0 ]; then
-       # Only delete if successful
-               rm -rf $local_path/
-       else
-               find $local_path
        fi
 }
 
@@ -122,8 +138,6 @@ function rotate_timer_test ()
                while [ $i -le $expected_chunks ]; do
                        validate_trace_empty $local_path/${chunk_pattern}-$i
                        i=$(($i+1))
-       done
-fi
-
-       rm -rf $local_path
+               done
+       fi
 }
This page took 0.027848 seconds and 5 git commands to generate.